import sys


def news(cmd, nnews):
    frm, to = _getrange(cmd, nnews)
    return _build(frm, to)
    

def _getrange(cmd, nnews):
    if cmd == "top":
        return 0, nnews
    elif cmd == "archive":
        return nnews, sys.maxint
    else:
        return 0, 0


def _build(frm, to):
    date = ""
    s = '<dl class="ol_news">\n'
    for item in SelectItems(frm, to):
        if date != item.date():
            date = item.date()
            s += '  <dt>%s</dt>\n' % _format_date(date)
        s += '  <dd>%s</dd>\n' % (item.text)
    s += "</ul>"
    return s
    
    
def _format_date(date):
    return "%s.%s.%s" % (date[6:], date[4:6], date[:4])

    
def SelectItems(frm, to):
    i = 0
    for item in ListItems():
        if i >= to:
            return
        if i >= frm:
            yield item
        i += 1


def ListItems():
    for line in open("content/ol_news"):
        line = line.strip()
        if not line or line[0] == "#":
            continue
        dt, text = line.split(" ", 1)
        yield News(dt, text)
        

class News:
    def __init__(self, datetime, text):
        self.datetime = datetime
        self.text = text
        
    def date(self):
        return self.datetime[:8]
            
    def time(self):
        return self.datetime[8:]
